/* 📖 Bindery Controls v1.0.0 */
function ___$insertStyle(css) {
  if (!css) {
    return;
  }
  if (typeof window === 'undefined') {
    return;
  }

  var style = document.createElement('style');

  style.setAttribute('type', 'text/css');
  style.innerHTML = css;
  document.head.appendChild(style);

  return css;
}

import h from 'hyperscript';

// const p = 'bindery-';
var p = '📖-';

var prefix = function prefix(str) {
  return '' + p + str;
};
var prefixClass = function prefixClass(str) {
  return '.' + prefix(str);
};

var c = function c(str) {
  if (str[0] === '.') {
    return prefixClass(str.substr(1));
  }
  return prefix(str);
};

___$insertStyle("@charset \"UTF-8\";@media screen{.📖-viewing .📖-controls{display:flex!important}}.📖-controls{font:16px/1.4 -apple-system,BlinkMacSystemFont,Roboto,sans-serif;display:none;flex-direction:row;align-items:start;position:fixed;top:0;left:0;right:0;z-index:1;margin:auto;color:#000;padding:10px;overflow:visible;-webkit-font-smoothing:antialiased}.📖-controls *{font:inherit;color:inherit;margin:0;padding:0;box-sizing:border-box}.📖-controls a{color:var(--bindery-ui-accent,#0000c5);text-decoration:none}.📖-row{flex-wrap:wrap;align-items:start;cursor:default;user-select:none}.📖-row,.📖-title{position:relative;display:flex}.📖-title{padding:8px 16px;transition:opacity .2s;white-space:nowrap;overflow:hidden;margin-right:auto}.📖-print-options{display:flex;opacity:0;max-width:0;border-radius:4px;background:#e4e4e4;overflow:hidden;transition:all .4s;flex-wrap:nowrap;transition-delay:.2s}[bindery-view-mode=print] .📖-print-options{max-width:720px;margin-right:12px;opacity:1}.📖-in-progress .📖-print-options{opacity:0;display:none}.📖-controls .📖-print-options .📖-control{background-color:transparent}.📖-spinner{border:1px solid transparent;border-left-color:#000;width:20px;height:20px;border-radius:50%;vertical-align:middle;opacity:0;pointer-events:none;transition:all .2s;margin-right:16px}.📖-in-progress .📖-spinner{opacity:1;animation:spin .6s linear infinite}.📖-debug .📖-spinner{animation:spin 2s linear infinite}.📖-spinner.📖-paused{animation:none}@keyframes spin{0%{transform:rotate(0)}to{transform:rotate(1turn)}}.📖-controls .📖-btn{-webkit-appearance:none;cursor:pointer;display:inline-block;margin-right:8px;text-decoration:none}.📖-controls .📖-btn:hover{background:#ddd}.📖-controls .📖-btn:active{background:#eee}.📖-controls .📖-btn:last-child{margin-right:0}.📖-controls .📖-control{border-radius:4px;color:#000;padding:8px 16px;background-color:#f4f4f4;border:0}.📖-controls .📖-btn-light{background:none;border:none}.📖-controls .📖-btn-main{background:var(--bindery-ui-accent,#0000c5);border-color:var(--bindery-ui-accent,#0000c5);color:#fff}.📖-controls .📖-btn-main:hover{background:var(--bindery-ui-accent,#0000c5);opacity:.7}.📖-controls .📖-btn-main:active{background:#000;opacity:1}.📖-view-row{margin-left:auto;margin-right:12px;transition:all .5s}.📖-in-progress .📖-view-row{opacity:0;pointer-events:none}.📖-debug .📖-view-row{display:none}.📖-btn-print{transition:all .5s}.📖-in-progress .📖-btn-print{opacity:0;pointer-events:none}.📖-debug .📖-btn-print{display:none}.📖-controls .📖-select-wrap{padding-right:32px;background-image:url(\"data:image/svg+xml;charset=utf-8,%3Csvg width='32' height='32' xmlns='http://www.w3.org/2000/svg'%3E%3Cpath d='M11 14l5 5 5-5' stroke='%23000' fill='none'/%3E%3C/svg%3E\");background-repeat:no-repeat;background-position:100%;transition:all .2s;white-space:nowrap;width:100%}.📖-controls .📖-select-wrap:active,.📖-controls .📖-select-wrap:hover{background-color:#ddd}.📖-controls .📖-select-wrap.📖-hidden-select{max-width:0;padding-left:0;padding-right:0;border-left-width:0;border-right-width:0;color:transparent}.📖-select{position:absolute;top:0;left:0;opacity:0;-webkit-appearance:none;-moz-appearance:none;padding:8px 16px;color:#000;border:transparent;width:100%}.📖-debug-controls{display:none}.📖-debug .📖-in-progress .📖-debug-controls{display:block}.📖-refresh-btns{opacity:0;position:absolute;top:0;left:0;padding:8px 0;transition:all .2s}.📖-in-progress .📖-refresh-btns{display:none}.📖-refresh-btns a{margin-left:1em;cursor:pointer}.📖-refresh-btns a:hover{color:#000}@media screen and (max-width:720px){.📖-print-options{max-width:unset;max-height:0}[bindery-view-mode=print] .📖-print-options{max-width:unset;max-height:240px;margin:0}.📖-root{transition:all .2s}[bindery-view-mode=print].📖-root{padding-top:120px}.📖-controls{height:98px}.📖-view-row{margin-left:auto}.📖-print-options{top:54px;right:10px;position:fixed;margin:0}.📖-print-options .📖-row{margin:0}}@media screen and (max-width:500px){[bindery-view-mode=print].📖-root{padding-top:190px}[bindery-view-mode=print].📖-root .📖-controls{background:#f4f4f4;height:170px}.📖-print-options{flex-direction:column;align-items:stretch;left:10px}.📖-hidden-select{display:none}}");

var title = function title() {
  for (var _len = arguments.length, arg = Array(_len), _key = 0; _key < _len; _key++) {
    arg[_key] = arguments[_key];
  }

  return h.apply(undefined, [c('.title')].concat(arg));
};

var row = function row() {
  for (var _len3 = arguments.length, arg = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
    arg[_key3] = arguments[_key3];
  }

  return h.apply(undefined, [c('.row')].concat(arg));
};

// Button
var btn = function btn() {
  for (var _len4 = arguments.length, arg = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
    arg[_key4] = arguments[_key4];
  }

  return h.apply(undefined, ['button' + c('.control') + c('.btn')].concat(arg));
};

var btnMain = function btnMain() {
  for (var _len6 = arguments.length, arg = Array(_len6), _key6 = 0; _key6 < _len6; _key6++) {
    arg[_key6] = arguments[_key6];
  }

  return h.apply(undefined, ['button' + c('.control') + c('.btn') + c('.btn-main')].concat(arg));
};

var select = function select() {
  var selectVal = h(c('.select-val'), 'Value');

  for (var _len7 = arguments.length, arg = Array(_len7), _key7 = 0; _key7 < _len7; _key7++) {
    arg[_key7] = arguments[_key7];
  }

  var selectEl = h.apply(undefined, ['select.' + c('select')].concat(arg));
  var updateVal = function updateVal() {
    selectVal.textContent = selectEl.options[selectEl.selectedIndex].text;
  };
  selectEl.addEventListener('change', updateVal);
  updateVal();
  return h('' + c('.select-wrap') + c('.control'), selectVal, selectEl);
};

var option = function option() {
  for (var _len8 = arguments.length, arg = Array(_len8), _key8 = 0; _key8 < _len8; _key8++) {
    arg[_key8] = arguments[_key8];
  }

  return h.apply(undefined, ['option'].concat(arg));
};

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};











































var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

var supportsCustomPageSize = !!window.chrome && !!window.chrome.webstore;

var Controls = function Controls(availableOptions, initialState, actions) {
  classCallCheck(this, Controls);
  var Mode = availableOptions.Mode,
      Paper = availableOptions.Paper,
      Layout = availableOptions.Layout,
      Marks = availableOptions.Marks;


  var viewSelect = void 0;
  var marksSelect = void 0;
  var spinner = void 0;

  var print = function print() {
    actions.setMode(Mode.PRINT);

    var sel = viewSelect.querySelector('select');
    sel.value = Mode.PRINT;
    sel.dispatchEvent(new Event('change'));

    setTimeout(window.print, 10);
  };

  var printBtn = btnMain({ onclick: print }, 'Print');

  var paperSizes = (supportsCustomPageSize ? [option({ value: Paper.AUTO }, 'Auto'), option({ value: Paper.AUTO_BLEED }, 'Auto + Bleed'), option({ value: Paper.AUTO_MARKS }, 'Auto + Marks'), option({ value: Paper.LETTER_PORTRAIT }, 'Letter Portrait'), option({ value: Paper.LETTER_LANDSCAPE }, 'Letter Landscape'), option({ value: Paper.A4_PORTRAIT }, 'A4 Portrait'), option({ value: Paper.A4_LANDSCAPE }, 'A4 Landscape')] : [option({ value: Paper.LETTER_PORTRAIT, selected: true }, 'Default Page Size *'), option({ disabled: true }, 'Only Chrome supports custom page sizes. Set in your browser\'s print dialog instead.')]).map(function (opt) {
    if (opt.value === initialState.paper) {
      opt.selected = true;
    }
    return opt;
  });

  var updateSheetSizeNames = function updateSheetSizeNames() {
    if (!supportsCustomPageSize) return;
    var size = actions.getPageSize();
    var sizeName = size.width + ' \xD7 ' + size.height;
    paperSizes[0].textContent = '' + sizeName;
    paperSizes[1].textContent = sizeName + ' + Bleed';
    paperSizes[2].textContent = sizeName + ' + Marks';
  };
  updateSheetSizeNames();

  var updatePaper = function updatePaper(e) {
    var newVal = e.target.value;
    actions.setPaper(newVal);
    if (newVal === Paper.AUTO || newVal === Paper.AUTO_BLEED) {
      marksSelect.classList.add(c('hidden-select'));
    } else {
      marksSelect.classList.remove(c('hidden-select'));
    }
  };

  var sheetSizeSelect = select.apply(undefined, [{ onchange: updatePaper }].concat(toConsumableArray(paperSizes)));

  var layoutSelect = select.apply(undefined, [{ onchange: function onchange(e) {
      actions.setLayout(e.target.value);
      updateSheetSizeNames();
    } }].concat(toConsumableArray([option({ value: Layout.PAGES }, '1 Page / Sheet'), option({ value: Layout.SPREADS }, '1 Spread / Sheet'), option({ value: Layout.BOOKLET }, 'Booklet Sheets')].map(function (opt) {
    if (opt.value === initialState.layout) {
      opt.selected = true;
    }
    return opt;
  }))));
  var arrangement = row(layoutSelect);

  marksSelect = select.apply(undefined, [{ onchange: function onchange(e) {
      return actions.setMarks(e.target.value);
    } }].concat(toConsumableArray([option({ value: Marks.NONE }, 'No Marks'), option({ value: Marks.CROP, selected: true }, 'Crop Marks'), option({ value: Marks.BLEED }, 'Bleed Marks'), option({ value: Marks.CROP }, 'Crop and Bleed')].map(function (opt) {
    if (opt.value === initialState.marks) {
      opt.selected = true;
    }
    return opt;
  }))));
  if (supportsCustomPageSize) {
    marksSelect.classList.add(c('hidden-select'));
  }
  var marks = row(marksSelect);
  var sheetSize = row(sheetSizeSelect);

  var headerContent = h('span', 'Loading');

  var playSlow = void 0;
  var step = btn('→', {
    style: { display: 'none' },
    onclick: function onclick() {
      window.binderyDebug.step();
      document.scrollingElement.scrollTop = document.scrollingElement.scrollHeight;
    }
  });
  var pause = btn('❙❙', {
    onclick: function onclick() {
      window.binderyDebug.pause();
      spinner.classList.add(c('paused'));
      pause.style.display = 'none';
      playSlow.style.display = '';
      step.style.display = '';
    }
  });
  playSlow = btn('▶️', {
    style: { display: 'none' },
    onclick: function onclick() {
      window.binderyDebug.resume();
      spinner.classList.remove(c('paused'));
      playSlow.style.display = 'none';
      pause.style.display = '';
      step.style.display = 'none';
    }
  });
  var debugDone = btn('Finish', {
    onclick: function onclick() {
      spinner.classList.remove(c('paused'));
      window.binderyDebug.finish();
    }
  });

  var debugControls = h(c('.debug-controls'), pause, playSlow, step, debugDone);

  spinner = h(c('.spinner'));
  var header = title(headerContent);

  this.setInProgress = function () {
    headerContent.textContent = 'Paginating';
  };

  var lastUpdate = 0;
  this.updateProgress = function (count) {
    var t = performance.now();
    if (t - lastUpdate > 100) {
      lastUpdate = t;
      headerContent.textContent = count + ' Pages';
    }
  };

  this.setDone = function (length) {
    headerContent.textContent = length + ' Pages';
  };

  this.setInvalid = function () {};

  printBtn.classList.add(c('btn-print'));
  var options = row(arrangement, sheetSize, marks);
  options.classList.add(c('print-options'));

  viewSelect = select.apply(undefined, [{ onchange: function onchange(e) {
      return actions.setMode(e.target.value);
    } }].concat(toConsumableArray([option({ value: Mode.PREVIEW }, 'Preview'), option({ value: Mode.FLIPBOOK }, 'Flipbook'), option({ value: Mode.PRINT }, 'Print Preview')].map(function (opt) {
    if (opt.value === initialState.mode) {
      opt.selected = true;
    }
    return opt;
  }))));
  var viewRow = row(viewSelect);
  viewRow.classList.add(c('view-row'));

  this.element = h(c('.controls'), header, debugControls, viewRow, options, printBtn);
};

export default Controls;
